#ifndef BOLA_H
#define BOLA_H

#include "main.h"

#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>

#define RAIO_BOLA 0.1f
#define SLICES 25
#define STACKS 25

#define X -0.33
#define Y  0.101
#define Z -5.67
#define V_X  1.9f
#define V_Y  1.7f
#define V_Z -2.9f



struct bola {
    GLUquadricObj *esfera;
    GLfloat posBola[3];
    GLfloat velBola[3];
    /*
     * SDL_Surface *superficie; < penso que isto no  preciso 
     */
    GLuint texture[1];
    int nChoques;
};

void initBola(void);
void desenhaBola(void);
void resetChoques();
void actualizaBola(float deltaT);
void viraBolaDireita();
void viraBolaEsquerda();
GLfloat getVXbola();
GLfloat getVYbola();
GLfloat getXbola();
GLfloat getYbola();
GLfloat getVZbola();
void resetBola();
void inqChoque();
int getChoques();

#endif
