#ifdef _WIN32
#include <windows.h>
#endif

#include "controlo.h"

int Sair(int codigoRetornado)
{
    /*
     * Limpar a janela 
     */
    SDL_Quit();

    /*
     * e sair devidamente 
     */
    exit(codigoRetornado);
}

int carregaTeclado(SDL_keysym * keysym)
{

    if (!inMenu) {
      //Teclado no jogo
	switch (keysym->sym) {
	case SDLK_ESCAPE:	// ESC, logo sair do programa
	  inMenu=TRUE;
	  resetBola();
	    break;
	case SDLK_F1:
	    return 1;		// F1, mudar para ecran completo
	    break;
	case SDLK_RIGHT:
	    setPadVx(0, 0.04);	// Velocidade positiva no X
	    break;
	case SDLK_LEFT:
	    setPadVx(0, -0.04);
	    break;
	case SDLK_UP:
	    setPadVy(0, 0.04);
	    break;
	case SDLK_DOWN:
	    setPadVy(0, -0.04);
	    break;
	default:
	    break;
	}
    } else {
      //TODO
      //Teclado no menu
	switch (keysym->sym) {
	case SDLK_ESCAPE:	// ESC, logo sair do programa
	    Sair(0);
	    break;
	case SDLK_1:
	  inMenu=FALSE;
	  resetChoques();
	  resetPad();
	  setPadVy(0,0);
	  setPadVx(0,0);
     	  resetBola();
	  break;
	case SDLK_2:
	  break;
	case SDLK_0:
	  Sair(0);
	  break;
	default:
	  break;
	}
    }
    return 0;
}

int largaTeclado(SDL_keysym * keysym)
{

    switch (keysym->sym) {
    case SDLK_RIGHT:
	setPadVx(0, 0.0);
	break;
    case SDLK_LEFT:
	setPadVx(0, 0.0);
	break;
    case SDLK_UP:
	setPadVy(0, 0.0);
	break;
    case SDLK_DOWN:
	setPadVy(0, 0.0);
	break;
    default:
	break;
    }

    return 0;
}
