#ifndef PAD_H
#define PAD_H


#include "main.h"


#include <GL/gl.h>
#include <GL/glu.h>
#include <SDL.h>

#define LARGURA 0.8f
#define ALTURA 0.6f

struct pad {
    GLfloat posPad[3][2];
    GLuint texture[1];
    GLfloat velPad[3][2];
};


void initPad();
void desenhaPad(int i);

void setPadVx(int i, GLfloat vx);
void setPadVy(int i, GLfloat vy);

GLfloat getXpad(int i);
void resetPad();
GLfloat getYpad(int i);
int chocaPad(GLfloat * crdbola, int i);
/*
 * void actualizaPad(int i, GLfloat x, GLfloat y); 
 */
void actualizaPad(int i);
void incrementaPadx();
void decrementaPadx();
void incrementaPady();
void decrementaPady();

#endif
