#ifdef _WIN32
#include <windows.h>
#endif

#include "pad.h"
#include "bola.h"
#include "paredes.h"



/*
 * Muito incompleto pois no sei inicializar as paredes :) mas depois de
 * ter todas basta chamar isto no main para inicializar as ditas. E depois 
 * podes usar glVertex3fv( pSuperior.a ); HAAAA e NO EXISTEM BOOLEANS EM
 * C. 
 */

struct parede pCimo, pBaixo, pDireita, pEsquerda, pFundo;

static char textura[100] = "data/video/Sky.bmp";

static SDL_Surface *ImagemTextura[1];

/*
 * Pontos do cubo de jogo 
 */
GLfloat d[3] = { X_ESQ, Y_CIMA, RAIZ };
GLfloat c[3] = { X_DIR, Y_CIMA, RAIZ };
GLfloat b[3] = { X_DIR, Y_BAIXO, RAIZ };
GLfloat a[3] = { X_ESQ, Y_BAIXO, RAIZ };
GLfloat h[3] = { X_ESQ, Y_CIMA, PROFUNDIDADE };
GLfloat g[3] = { X_DIR, Y_CIMA, PROFUNDIDADE };
GLfloat f[3] = { X_DIR, Y_BAIXO, PROFUNDIDADE };
GLfloat e[3] = { X_ESQ, Y_BAIXO, PROFUNDIDADE };

/*
 * Pontos da parede do fundo 
 */
GLfloat i[3] = { X_ESQ_FUNDO, Y_BAIXO_FUNDO, FUNDO };
GLfloat j[3] = { X_DIR_FUNDO, Y_BAIXO_FUNDO, FUNDO };
GLfloat k[3] = { X_DIR_FUNDO, Y_CIMA_FUNDO, FUNDO };
GLfloat l[3] = { X_ESQ_FUNDO, Y_CIMA_FUNDO, FUNDO };


void initParede()
{
    int estado = FALSE;


    pCimo.a = d;
    pCimo.b = c;
    pCimo.c = g;
    pCimo.d = h;

    pBaixo.a = a;
    pBaixo.b = b;
    pBaixo.c = f;
    pBaixo.d = e;

    pEsquerda.a = a;
    pEsquerda.b = e;
    pEsquerda.c = h;
    pEsquerda.d = d;

    pDireita.a = b;
    pDireita.b = f;
    pDireita.c = g;
    pDireita.d = c;

    pFundo.a = i;
    pFundo.b = j;
    pFundo.c = k;
    pFundo.d = l;


    if ((ImagemTextura[0] = SDL_LoadBMP(textura))) {
	estado = TRUE;
	glGenTextures(1, &pFundo.texture[0]);

	//Mais uma tripe do Window$
#ifdef _WIN32
#define GL_BGR GL_BGR_EXT
#endif

	glTexImage2D(GL_TEXTURE_2D, 0, 3, ImagemTextura[0]->w,
		     ImagemTextura[0]->h, 0, GL_BGR,
		     GL_UNSIGNED_BYTE, ImagemTextura[0]->pixels);

	gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, ImagemTextura[0]->w,
			  ImagemTextura[0]->h, GL_BGR, GL_UNSIGNED_BYTE,
			  ImagemTextura[0]->pixels);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
			/*
			 * GL_NEAREST ); 
			 */
			GL_LINEAR_MIPMAP_LINEAR);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
			GL_LINEAR_MIPMAP_LINEAR);

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    }
    /*
     * if (ImagemTextura[0]) SDL_FreeSurface(ImagemTextura[0]); 
     */


}

void desenhaParede()
{


    glLoadIdentity();



    glBegin(GL_QUADS);

    glEnable(GL_TEXTURE_2D);

    glColor3f(1.0, 1.0, 1.0);
    glBindTexture(GL_TEXTURE_2D, pFundo.texture[0]);
    glTexCoord2f(0.0, 0.0);
    glVertex3fv(pFundo.a);
    glTexCoord2f(1.0, 0.0);
    glVertex3fv(pFundo.b);
    glTexCoord2f(1.0, 1.0);
    glVertex3fv(pFundo.c);
    glTexCoord2f(0.0, 1.0);
    glVertex3fv(pFundo.d);
    glEnd();

    glDisable(GL_TEXTURE_2D);

    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
    glBegin(GL_QUADS);

    glColor4f(1.0f, 1.0f, 0.0f, 0.5f);


    glVertex3fv(pCimo.a);	/* LU */
    glVertex3fv(pCimo.b);	/* RU */
    glVertex3fv(pCimo.c);
    glVertex3fv(pCimo.d);

    glVertex3fv(pBaixo.a);
    glVertex3fv(pBaixo.b);
    glVertex3fv(pBaixo.c);
    glVertex3fv(pBaixo.d);


    glColor4f(0.0f, 1.0f, 0.0f, 0.5f);

    glVertex3fv(pEsquerda.a);
    glVertex3fv(pEsquerda.b);
    glVertex3fv(pEsquerda.c);
    glVertex3fv(pEsquerda.d);

    glVertex3fv(pDireita.a);
    glVertex3fv(pDireita.b);
    glVertex3fv(pDireita.c);
    glVertex3fv(pDireita.d);

    glEnd();
    glDepthMask(GL_TRUE);
    glDisable(GL_BLEND);

}

/*
 * Malditos ponteiros que depois fica uma salgalhada com x++ e x-2 e cenas 
 * que tal 
 *
 Esta parte do codigo esta uma miseria Francisco
 Tem de haver uma maneira melhor (em termos de algoritmo) de fazer isto */

void choqueParede(GLfloat * coordenadas)
{
    int xu = FALSE, i;
    GLfloat batex = 0, raio = coordenadas[3];
    GLfloat *crdbola = &coordenadas[0];
    int yu = FALSE;
    GLfloat batey = 0, batez = 0;

    while (!xu) {
	if (((coordenadas[0]) < (X_ESQ + raio))
	    || ((coordenadas[0]) > (X_DIR - raio))) {
	    coordenadas[0] = (coordenadas[0] > 0 ? X_DIR : X_ESQ) - (coordenadas[0] - ((coordenadas[0] > 0 ? (X_DIR - 2 * raio) : (X_ESQ + 2 * raio))));	// Trata do eixo dos x 
	    batex++;
	}
	//DEBUG
	//	printf(" %f , %f \n", coordenadas[0], batex);
	if ((coordenadas[0] >= (X_ESQ + raio))  && (coordenadas[0] <= (X_DIR - raio)))
	    xu = TRUE;
    }



    while (!yu) {
	if ((coordenadas[1] < (Y_BAIXO + raio))
	    || (coordenadas[1] > (Y_CIMA - raio))) {
	    coordenadas[1] = (coordenadas[1] > 0 ? Y_CIMA : Y_BAIXO) - (coordenadas[1] - ((coordenadas[1] > 0 ? (Y_CIMA - 2 * raio) : (Y_BAIXO + 2 * raio))));	// Trata do eixo dos y      
	    batey++;
	}
	//DEBUG
	//printf(" Y ");
	if ((coordenadas[1] <= (Y_CIMA - raio))
	    && (coordenadas[1] >= (Y_BAIXO + raio)))
	    yu = TRUE;
    }

    /* Vamos tocar os sons do choque com as paredes */
    for (i = 1; i <= (batex + batey); i++) {
	bounceWall();
    }


    if (((coordenadas[2] < PROFUNDIDADE + 1)
	 && (coordenadas[2] >= PROFUNDIDADE + raio)) && getVZbola() < 0) {
	if (chocaPad(crdbola, 1)) {
          batez = 1;
	    /* N\x{00E3}o percebo porque \x{00E9} que isto s\x{00E3}o floats (o batex, batey e batez) */
	}
    }

    else if (((coordenadas[2] > RAIZ - 1)
	      && (coordenadas[2] <= RAIZ - raio)) && getVZbola() > 0)
	if (chocaPad(crdbola, 0))
          {
	    if(!inMenu)
	      inqChoque();
	    batez = 1;
	  }
    if (coordenadas[2] < PROFUNDIDADE) {

	goal();
	/*	glLoadIdentity();
	glTranslatef(-0.6f,0.0f,-0.1f);
	glPrint("O computador perdeu... FANTASTICO");
	SDL_Delay(10000); */
        inMenu=TRUE;
	SDL_Delay(3000);
	resetBola();

    }

    if (coordenadas[2] > RAIZ) {


	goal();
	/*       glLoadIdentity();
	glTranslatef(-0.6f,0.0f,-0.1f);
	glPrint("Conseguiu %d batidas", getChoques());
	SDL_Delay(10000); */

	inMenu=TRUE;
	resetBola();

    }

    coordenadas[4] = batex;
    coordenadas[5] = batey;
    coordenadas[6] = batez;

}
