#ifdef _WIN32
#include <windows.h>
#endif

#include "pad.h"
#include "paredes.h"




// Medidas negativas? Uma medida  sempre positiva
// PROFUNDIDADE? O que  a profundidade? Algo que tem a ver com a
// profundidade
// do campo de jogo? Isso deve provavelmente estar no main.c junto das
// cenas da resoluo





struct pad pads;


void initPad()
{
    pads.posPad[0][0] = 0.0f;	/* x,y,z pad 1 */
    pads.posPad[1][0] = 0.0f;
    pads.posPad[2][0] = RAIZ;
    pads.posPad[0][1] = 0.0f;	/* x,y,z pad 2 */
    pads.posPad[1][1] = 0.0f;
    pads.posPad[2][1] = PROFUNDIDADE;
}


void desenhaPad(int i)		// ou desenhamos o pad 1 ou 0 (o 0  o do
				// jogador)
{
    if (i == 0) {
	glLoadIdentity();
	glTranslatef(pads.posPad[0][i], pads.posPad[1][i],
		     pads.posPad[2][i]);
	glDepthMask(GL_FALSE);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glBegin(GL_QUADS);
	glColor4f(1.0f, 0.0f, 0.7f, 0.5f);
	glVertex3f(0.0f, 0.0f, 0.0f);
	glVertex3f(LARGURA, 0.0f, 0.0f);
	glVertex3f(LARGURA, ALTURA, 0.0f);
	glVertex3f(0.0f, ALTURA, 0.0f);
	glEnd();
	glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
    }

    else if (i == 1) {
	glLoadIdentity();
	glTranslatef(pads.posPad[0][i], pads.posPad[1][i],
		     pads.posPad[2][i]);
	glBegin(GL_QUADS);
	glVertex3f(0.0f, 0.0f, 0.0f);
	glVertex3f(LARGURA, 0.0f, 0.0f);
	glVertex3f(LARGURA, ALTURA, 0.0f);
	glVertex3f(0.0f, ALTURA, 0.0f);
	glEnd();
    }

}


int chocaPad(GLfloat * crdbola, int i)
{
    /*Identei isto um pouco e limpei os ponteiros como na parede
     *para ver se percebo o buggaro */
    int choquex = 0, choquey = 0;

    if (((crdbola[0]) <= pads.posPad[0][i] + LARGURA - (crdbola[3]) ) && ((crdbola[0]) >= pads.posPad[0][i] + crdbola[3]))
	choquex = TRUE;

    if (((crdbola[1]) >= pads.posPad[1][i] + crdbola[3]) && ((crdbola[1]) <= pads.posPad[1][i] + ALTURA - crdbola[3]))
	choquey = TRUE;
    if (choquex && choquey) {
	bouncePad();
    }
    return (choquex && choquey);

    return (0);
}



    //  Comentei isto para testar a minha ideia sobre como fazer isto. 
/*void actualizaPad(int i, GLfloat x, GLfloat y) 
 { 
  pads.posPad[0][i]=x;
    pads.posPad[1][i]=y;
  if(pads.posPad[0][i]>X_DIR-LARGURA)pads.posPad[0][i]=X_DIR-LARGURA;
  else if(pads.posPad[0][i]<X_ESQ)pads.posPad[0][i]=X_ESQ; else
  if(pads.posPad[1][i]>Y_CIMA)pads.posPad[1][i]=Y_CIMA; else
  if(pads.posPad[1][i]<Y_BAIXO+ALTURA)pads.posPad[1][i]=Y_BAIXO+ALTURA; 
  }*/



void actualizaPad(int i)
{
    if (pads.velPad[0][i] != 0 )
      {
	pads.posPad[0][i] = pads.posPad[0][i] + pads.velPad[0][i];
	if ( pads.posPad[0][i] > X_DIR - LARGURA )
	  pads.posPad[0][i] = X_DIR - LARGURA;
	else if ( pads.posPad[0][i] < X_ESQ )
	  pads.posPad[0][i] = X_ESQ;
      }

    if (pads.velPad[1][i] != 0)
      { 
	pads.posPad[1][i] = pads.posPad[1][i] + pads.velPad[1][i];
        if ( pads.posPad[1][i] > Y_CIMA - ALTURA)
	  pads.posPad[1][i] = Y_CIMA - ALTURA;
	else if (pads.posPad[1][i] < Y_BAIXO)
	  pads.posPad[1][i] = Y_BAIXO;
      }
}



void resetPad()
{
  pads.posPad[0][0]=0;
  pads.posPad[1][0]=0;
  pads.posPad[0][1]=0;
  pads.posPad[1][1]=0;
}

GLfloat getXpad(int i)
{
    return (pads.posPad[0][i]);
}

GLfloat getYpad(int i)
{
    return (pads.posPad[1][i]);
}

void setPadVx(int i, GLfloat vx)
{
    pads.velPad[0][i] = vx;
}

void setPadVy(int i, GLfloat vy)
{
    pads.velPad[1][i] = vy;
}



void incrementaPadx()
{
    pads.posPad[0][0] = pads.posPad[0][0] + 0.1;
}

void decrementaPadx()
{
    pads.posPad[0][0] = pads.posPad[0][0] - 0.1;
}

void incrementaPady()
{
    pads.posPad[1][0] = pads.posPad[1][0] + 0.1;
}

void decrementaPady()
{
    pads.posPad[1][0] = pads.posPad[1][0] - 0.1;
}
